## xdmf 2.1.dfsg.1

=== CMakeLists.txt ===
#
CMAKE_MINIMUM_REQUIRED(VERSION 2.4)
PROJECT(Xdmf)
if(COMMAND cmake_policy)
    cmake_policy(SET CMP0003 NEW)
#    cmake_policy(SET CMP0003 OLD)
endif(COMMAND cmake_policy)
SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${Xdmf_SOURCE_DIR}/CMake)

OPTION(BUILD_SHARED_LIBS "Build Shared XDMF Library" ON)

# Disable deprecation warnings for standard C and STL functions in VS2005
# and later
IF(MSVC_VERSION EQUAL 1400 OR MSVC_VERSION GREATER 1400)
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE -D_CRT_SECURE_NO_WARNINGS)
  ADD_DEFINITIONS(-D_SCL_SECURE_NO_DEPRECATE -D_SCL_SECURE_NO_WARNINGS) 
ENDIF(MSVC_VERSION EQUAL 1400 OR MSVC_VERSION GREATER 1400) 

IF(NOT BUILD_SHARED_LIBS)
  SET(CMAKE_C_FLAGS -fPIC)
  SET(CMAKE_CXX_FLAGS -fPIC)
ENDIF(NOT BUILD_SHARED_LIBS)

# We need ansi c-flags, especially on HP
SET(CMAKE_REQUIRED_FLAGS ${CMAKE_ANSI_CFLAGS})

# Platform configuration tests.
INCLUDE(${CMAKE_ROOT}/Modules/CMakeBackwardCompatibilityC.cmake)
INCLUDE(${CMAKE_ROOT}/Modules/CMakeBackwardCompatibilityCXX.cmake)

SET(XDMF_INSTALL_DIR_CONFIG ${Xdmf_BINARY_DIR})
INCLUDE_DIRECTORIES(
  ${Xdmf_SOURCE_DIR}/libsrc
  ${Xdmf_BINARY_DIR}/libsrc)

SET (LIBRARY_OUTPUT_PATH ${Xdmf_BINARY_DIR}/bin/ CACHE PATH 
  "Single output directory for building all libraries.")
SET (EXECUTABLE_OUTPUT_PATH ${Xdmf_BINARY_DIR}/bin/ CACHE PATH 
  "Single output directory for building all executables.")

INCLUDE (${CMAKE_ROOT}/Modules/CheckLibraryExists.cmake)
INCLUDE (${CMAKE_ROOT}/Modules/CheckIncludeFile.cmake)

SET(VTK_INSTALL_LIB_DIR "/lib")

OPTION(XDMF_MEMORY_DEBUG "Enable Memory Debugging in Xdmf" OFF)
IF(XDMF_MEMORY_DEBUG)
  SET(CMAKE_BUILD_TYPE "Debug")
  ADD_DEFINITIONS(-DH5_USING_PURIFY -DXDMF_MEMORY_DEBUG)
ENDIF(XDMF_MEMORY_DEBUG)

############################################################################
# Metis

IF(XDMF_BUILD_UTILS)
    SET(XDMF_METIS_LIBRARIES metis)
    SET(METIS_INCLUDE_DIRS "${Xdmf_SOURCE_DIR}/Utilities/metis")
    INCLUDE_DIRECTORIES(${METIS_INCLUDE_DIRS})

    ADD_SUBDIRECTORY(Utilities/metis)

    # Set config.cmake paths
    SET(XDMF_METIS_INCLUDE_DIR_CONFIG ${METIS_INCLUDE_DIRS})
    SET(XDMF_METIS_INCLUDE_DIR_INSTALL_CONFIG ${CMAKE_INSTALL_PREFIX}/include/metis)
    SET(XDMF_METIS_LIBRARY_DIR_CONFIG ${Xdmf_BINARY_DIR}/bin)
    SET(XDMF_METIS_LIBRARY_DIR_INSTALL_CONFIG ${CMAKE_INSTALL_PREFIX}/lib)
ENDIF(XDMF_BUILD_UTILS)

#############################################################################
# VTK READER/WRITER to use .xdmf files in vtk

INCLUDE(vtkThirdParty)
OPTION(XDMF_BUILD_VTK "Build VTK reader" OFF)

IF(XDMF_BUILD_VTK)
  FIND_PACKAGE(VTK REQUIRED)
  IF(VTK_FOUND)
    INCLUDE(${VTK_USE_FILE})
  ENDIF(VTK_FOUND)
ELSE(XDMF_BUILD_VTK)
  SET(VTK_DIR)
ENDIF(XDMF_BUILD_VTK)

#############################################################################
# ZLIB LIBRARY

IF(XDMF_BUILD_VTK)
  
  # Zlib from vtk
  SET(XDMF_ZLIB_LIBRARIES ${VTK_ZLIB_LIBRARIES})
  IF(NOT VTK_USE_SYSTEM_ZLIB)
    SET(HDF5_ZLIB_INCLUDE_DIRS ${VTK_INSTALL_PREFIX}${VTK_INSTALL_INCLUDE_DIR};${VTK_INSTALL_PREFIX}${VTK_INSTALL_INCLUDE_DIR}/vtkzlib)
    INCLUDE_DIRECTORIES(${HDF5_ZLIB_INCLUDE_DIRS})
    SET(HDF5_ZLIB_HEADER "vtkzlib/zlib.h")

    # Set config.cmake paths
    SET(XDMF_ZLIB_INCLUDE_DIR_CONFIG ${HDF5_ZLIB_INCLUDE_DIRS})
    SET(XDMF_ZLIB_INCLUDE_DIR_INSTALL_CONFIG ${XDMF_ZLIB_INCLUDE_DIR_CONFIG})
    SET(XDMF_ZLIB_LIBRARY_DIR_CONFIG ${VTK_LIBRARY_DIRS})
    SET(XDMF_ZLIB_LIBRARY_DIR_INSTALL_CONFIG ${XDMF_ZLIB_LIBRARY_DIR_CONFIG})

  ENDIF(NOT VTK_USE_SYSTEM_ZLIB)

ELSE(XDMF_BUILD_VTK)

  OPTION(XDMF_SYSTEM_ZLIB "Use system Zlib" OFF)
  IF(XDMF_SYSTEM_ZLIB)
  
    # Use a zlib that is installed on the machine somewhere
    FIND_PACKAGE(ZLIB REQUIRED)
    SET(XDMF_ZLIB_LIBRARIES ${ZLIB_LIBRARY})
    SET(HDF5_ZLIB_INCLUDE_DIRS ${ZLIB_INCLUDE_DIR})

    # Set config.cmake paths
    SET(XDMF_ZLIB_INCLUDE_DIR_CONFIG ${ZLIB_INCLUDE_DIR})
    SET(XDMF_ZLIB_INCLUDE_DIR_INSTALL_CONFIG ${XDMF_ZLIB_INCLUDE_DIR_CONFIG})
    GET_FILENAME_COMPONENT(XDMF_ZLIB_LIBRARY_DIR_CONFIG ${ZLIB_LIBRARY} PATH)
    SET(XDMF_ZLIB_LIBRARY_DIR_INSTALL_CONFIG ${XDMF_ZLIB_LIBRARY_DIR_CONFIG})
  
  ELSE(XDMF_SYSTEM_ZLIB)

    # Build our own vtkzlib
    SUBDIRS(Utilities/vtkzlib)

    SET(HDF5_ZLIB_INCLUDE_DIRS "${Xdmf_BINARY_DIR}/Utilities/vtkzlib;${Xdmf_BINARY_DIR}/Utilities;${Xdmf_SOURCE_DIR}/Utilities;${Xdmf_SOURCE_DIR}/Utilities/vtkzlib")
    INCLUDE_DIRECTORIES(${HDF5_ZLIB_INCLUDE_DIRS})
    SET(HDF5_ZLIB_HEADER "vtkzlib/zlib.h")
    
    # Set config.cmake paths
    SET(XDMF_ZLIB_INCLUDE_DIR_CONFIG ${HDF5_ZLIB_INCLUDE_DIRS})
    SET(XDMF_ZLIB_INCLUDE_DIR_INSTALL_CONFIG ${CMAKE_INSTALL_PREFIX}/include/vtkzlib)
    SET(XDMF_ZLIB_LIBRARY_DIR_CONFIG ${Xdmf_BINARY_DIR}/bin)
    SET(XDMF_ZLIB_LIBRARY_DIR_INSTALL_CONFIG ${CMAKE_INSTALL_PREFIX}/lib)
    SET(XDMF_ZLIB_LIBRARIES vtkzlib)

  ENDIF(XDMF_SYSTEM_ZLIB)

ENDIF(XDMF_BUILD_VTK)

#############################################################################
# NETCDF LIBRARY

IF(XDMF_BUILD_UTILS)
  IF(XDMF_BUILD_VTK AND EXISTS ${VTK_INSTALL_PREFIX}${VTK_INSTALL_INCLUDE_DIR}/vtk_netcdf.h)
   
    # NetCDF library from vtk
    SET(XDMF_NETCDF_LIBRARIES vtkNetCDF)
    SET(NETCDF_INCLUDE_DIRS ${VTK_INSTALL_PREFIX}${VTK_INSTALL_INCLUDE_DIR}/vtknetcdf)
    INCLUDE_DIRECTORIES(${NETCDF_INCLUDE_DIRS})

    # Set config.cmake paths
    SET(XDMF_NETCDF_INCLUDE_DIR_CONFIG ${VTK_INSTALL_PREFIX}${VTK_INSTALL_INCLUDE_DIR}/vtknetcdf)
    SET(XDMF_NETCDF_INCLUDE_DIR_INSTALL_CONFIG ${XDMF_NETCDF_INCLUDE_DIR_CONFIG})
    SET(XDMF_NETCDF_LIBRARY_DIR_CONFIG ${VTK_LIBRARY_DIRS})
    SET(XDMF_NETCDF_LIBRARY_DIR_INSTALL_CONFIG ${XDMF_NETCDF_LIBRARY_DIR_CONFIG})
  
  ELSE(XDMF_BUILD_VTK AND EXISTS ${VTK_INSTALL_PREFIX}${VTK_INSTALL_INCLUDE_DIR}/vtk_netcdf.h)

    # Build our own vtknetcdf library
    ADD_SUBDIRECTORY(Utilities/vtknetcdf)

    SET(XDMF_NETCDF_LIBRARIES vtkNetCDF)
    SET(NETCDF_INCLUDE_DIRS "${Xdmf_BINARY_DIR}/Utilities/vtknetcdf;${Xdmf_SOURCE_DIR}/Utilities/vtknetcdf")
    INCLUDE_DIRECTORIES(${NETCDF_INCLUDE_DIRS})
    
    SET(XDMF_NETCDF_INCLUDE_DIR_CONFIG ${NETCDF_INCLUDE_DIRS})
    SET(XDMF_NETCDF_INCLUDE_DIR_INSTALL_CONFIG ${CMAKE_INSTALL_PREFIX}/include/vtknetcdf)
    SET(XDMF_NETCDF_LIBRARY_DIR_CONFIG ${CMAKE_INSTALL_PREFIX}/bin)
    SET(XDMF_NETCDF_LIBRARY_DIR_INSTALL_CONFIG ${CMAKE_INSTALL_PREFIX}/lib)
  
  ENDIF(XDMF_BUILD_VTK AND EXISTS ${VTK_INSTALL_PREFIX}${VTK_INSTALL_INCLUDE_DIR}/vtk_netcdf.h)

ENDIF(XDMF_BUILD_UTILS)

#############################################################################
# EXODUSII LIBRARY

IF(XDMF_BUILD_UTILS)
  
  IF(XDMF_BUILD_VTK AND EXISTS ${VTK_INSTALL_PREFIX}${VTK_INSTALL_INCLUDE_DIR}/vtkexodus2/exodusII.h)

    # Exodus library from vtk
    SET(XDMF_EXODUSII_LIBRARIES vtkexoIIc)
    SET(EXODUSII_INCLUDE_DIRS ${VTK_INSTALL_PREFIX}${VTK_INSTALL_INCLUDE_DIR}/vtkexodus2)
    INCLUDE_DIRECTORIES(${EXODUSII_INCLUDE_DIRS})

    # Set config.cmake paths
    SET(XDMF_EXODUSII_INCLUDE_DIR_CONFIG ${EXODUSII_INCLUDE_DIRS})
    SET(XDMF_EXODUSII_INCLUDE_DIR_INSTALL_CONFIG ${XDMF_EXODUSII_INCLUDE_DIR_CONFIG})
    SET(XDMF_EXODUSII_LIBRARY_DIR_CONFIG ${VTK_LIBRARY_DIRS})
    SET(XDMF_EXODUSII_LIBRARY_DIR_INSTALL_CONFIG ${XDMF_EXODUSII_LIBRARY_DIR_CONFIG})

  ELSE(XDMF_BUILD_VTK AND EXISTS ${VTK_INSTALL_PREFIX}${VTK_INSTALL_INCLUDE_DIR}/vtkexodus2/exodusII.h)

    # Build our own vtkexodus2 library
    ADD_SUBDIRECTORY(Utilities/vtkexodus2)

    SET(XDMF_EXODUSII_LIBRARIES vtkexoIIc)
    SET(EXODUSII_INCLUDE_DIRS "${Xdmf_BINARY_DIR}/Utilities/vtkexodus2/include;${Xdmf_SOURCE_DIR}/Utilities/vtkexodus2/include")
    INCLUDE_DIRECTORIES(${EXODUSII_INCLUDE_DIRS})
   
    # Set config.cmake paths
    SET(XDMF_EXODUSII_INCLUDE_DIR_CONFIG ${EXODUSII_INCLUDE_DIRS})
    SET(XDMF_EXODUSII_INCLUDE_DIR_INSTALL_CONFIG ${CMAKE_INSTALL_PREFIX}/include/vtkexodus2)
    SET(XDMF_EXODUSII_LIBRARY_DIR_CONFIG ${Xdmf_BINARY_DIR}/bin)
    SET(XDMF_EXODUSII_LIBRARY_DIR_INSTALL_CONFIG ${CMAKE_INSTALL_PREFIX}/lib)
 
  ENDIF(XDMF_BUILD_VTK AND EXISTS ${VTK_INSTALL_PREFIX}${VTK_INSTALL_INCLUDE_DIR}/vtkexodus2/exodusII.h)

ENDIF(XDMF_BUILD_UTILS)

#############################################################################
# XML2 LIBRARY

IF(XDMF_BUILD_VTK)
 
  # Libxml2 library from vtk
  SET(LIBXML2_LIBRARY ${VTK_LIBXML2_LIBRARIES})
  SET(XDMF_LIBXML2_INCLUDE_DIRS ${VTK_KITS_DIR}/vtklibxml2 ${VTK_INSTALL_PREFIX}${VTK_INSTALL_INCLUDE_DIR}/vtklibxml2)
  #SET(XDMF_LIBXML2_INCLUDE_DIRS ${VTK_INSTALL_PREFIX}${VTK_INSTALL_INCLUDE_DIR}/vtklibxml2)
  INCLUDE_DIRECTORIES(${XDMF_LIBXML2_INCLUDE_DIRS})

  # Set config.cmake paths
  SET(XDMF_LIBXML2_INCLUDE_DIR_CONFIG ${XDMF_LIBXML2_INCLUDE_DIRS})
  SET(XDMF_LIBXML2_INCLUDE_DIR_INSTALL_CONFIG ${XDMF_LIBXML2_INCLUDE_DIR_CONFIG})
  SET(XDMF_LIBXML2_LIBRARY_DIR_CONFIG ${VTK_LIBRARY_DIRS})
  SET(XDMF_LIBXML2_LIBRARY_DIR_INSTALL_CONFIG ${XDMF_LIBXML2_LIBRARY_DIR_CONFIG})
  SET(XDMF_LIBXML2_LIBRARIES ${LIBXML2_LIBRARY})

ELSE(XDMF_BUILD_VTK)
  OPTION(XDMF_SYSTEM_LIBXML2 "Use system libxml2" OFF)
  IF(NOT XDMF_SYSTEM_LIBXML2)

    # Build our own vtklibxml2.
    SUBDIRS(Utilities/vtklibxml2)
    
    SET(LIBXML2_LIBRARY vtklibxml2)
    SET(XDMF_LIBXML2_INCLUDE_DIRS "${Xdmf_BINARY_DIR}/Utilities/vtklibxml2")
    INCLUDE_DIRECTORIES(${XDMF_LIBXML2_INCLUDE_DIRS})

    # Set config.cmake paths
    SET(XDMF_LIBXML2_INCLUDE_DIR_CONFIG ${XDMF_LIBXML2_INCLUDE_DIRS})
    SET(XDMF_LIBXML2_INCLUDE_DIR_INSTALL_CONFIG ${CMAKE_INSTALL_PREFIX}/include/vtklibxml2)
    SET(XDMF_LIBXML2_LIBRARY_DIR_CONFIG ${Xdmf_BINARY_DIR}/bin)
    SET(XDMF_LIBXML2_LIBRARY_DIR_INSTALL_CONFIG ${CMAKE_INSTALL_PREFIX}/lib)
    SET(XDMF_LIBXML2_LIBRARIES ${LIBXML2_LIBRARY})

  ELSE(NOT XDMF_SYSTEM_LIBXML2)

    # Use a libxml2 that is installed on the machine somewhere.
    FIND_LIBRARY(LIBXML2_LIBRARY
      xml2
      /usr/lib64
      /usr/lib
      /usr/local/lib)
    FIND_PATH(LIBXML2_INCLUDE_PATH
      libxml
      /usr/include/libxml2
      /usr/include)
    INCLUDE_DIRECTORIES(${LIBXML2_INCLUDE_PATH}
      ${LIBXML2_INCLUDE_PATH}/libxml2)
    SET(LIBXML2_LIBRARY ${LIBXML2_LIBS})

    # Set config.cmake paths
    SET(XDMF_LIBXML2_INCLUDE_DIR_CONFIG ${LIBXML2_INCLUDE_PATH})
    SET(XDMF_LIBXML2_INCLUDE_DIR_INSTALL_CONFIG ${XDMF_LIBXML2_INCLUDE_DIR_CONFIG})
    GET_FILENAME_COMPONENT(XDMF_LIBXML2_LIBRARY_DIR_CONFIG ${LIBXML2_LIBRARY} PATH)
    SET(XDMF_LIBXML2_LIBRARY_DIR_INSTALL_CONFIG ${XDMF_LIBXML2_LIBRARY_DIR_CONFIG})
    SET(XDMF_LIBXML2_LIBRARIES ${LIBXML2_LIBRARY})

  ENDIF(NOT XDMF_SYSTEM_LIBXML2)
ENDIF(XDMF_BUILD_VTK)

IF(MSVC_VERSION EQUAL 1400 OR MSVC_VERSION GREATER 1400)
  ADD_DEFINITIONS(-D_CRT_SECURE_NO_DEPRECATE
    -D_CRT_NONSTDC_NO_DEPRECATE 
    -D_CRT_SECURE_NO_WARNINGS)
  ADD_DEFINITIONS(-D_SCL_SECURE_NO_DEPRECATE)
ENDIF(MSVC_VERSION EQUAL 1400 OR MSVC_VERSION GREATER 1400) 

#############################################################################
# MPI LIBRARY
OPTION(XDMF_BUILD_MPI "Build MPI Objects" ON)
SET(XDMF_MPI_LIBRARIES "")
IF(XDMF_BUILD_MPI)
    INCLUDE (${CMAKE_ROOT}/Modules/FindMPI.cmake)
    IF (MPI_INCLUDE_PATH)
      SET(XDMF_MPI_INCLUDE_PATH ${MPI_INCLUDE_PATH})
      INCLUDE_DIRECTORIES(${MPI_INCLUDE_PATH})
    ENDIF(MPI_INCLUDE_PATH)
    IF (MPI_LIBRARY)
      SET(XDMF_MPI_LIBRARIES ${XDMF_MPI_LIBRARIES} ${MPI_LIBRARY})
    ELSE (MPI_LIBRARY)
      MESSAGE(FATAL_ERROR 
        "Could not find the required MPI libraries, install MPI, or set MPI_INCLUDE_PATH and MPI_LIBRARY and MPI_EXTRA_LIBRARY, or turn XDMF_BUILD_MPI to OFF")
    ENDIF (MPI_LIBRARY)
    IF (MPI_EXTRA_LIBRARY)
      SET(XDMF_MPI_LIBRARIES ${XDMF_MPI_LIBRARIES} ${MPI_EXTRA_LIBRARY})
    ENDIF (MPI_EXTRA_LIBRARY)
ELSE(XDMF_BUILD_MPI)
    ADD_DEFINITIONS("-DXDMF_NO_MPI")
ENDIF(XDMF_BUILD_MPI)

#############################################################################
# HDF5 LIBRARY
OPTION(XDMF_SYSTEM_HDF5 "Use system HDF5" OFF)
IF(XDMF_SYSTEM_HDF5)
  OPTION(XDMF_SYSTEM_HDF5_IS_PARALLEL "HDF5 Built for MPI" OFF)
