=== Utilities/CMakeLists.txt ===
# SET(VTKHDF5_INSTALL_LIB_DIR /lib/Xdmf)
SET(VTKHDF5_INSTALL_LIB_DIR /lib)
SUBDIRS(hdf5)

IF(XDMF_BUILD_VTK)
  SUBDIRS(Doxygen)
ENDIF(XDMF_BUILD_VTK)

SET(VTK_INSTALL_LIB_DIR "/lib")
