=== debian/changelog ===
xdmf (2.1.dfsg.1-6build1) trusty; urgency=medium

  * No-change rebuild for libopenmpi1.3 -> libopenmpi1.6 transition.

 -- Logan Rosen <logan@ubuntu.com>  Mon, 16 Dec 2013 17:12:51 -0500

xdmf (2.1.dfsg.1-6) unstable; urgency=medium

  * Close old bug: Closes: #657607.
  * Standards-Version: 3.9.5 
  * Add proper versioned depends on debhelper 9.

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 09 Dec 2013 15:01:40 +0000

xdmf (2.1.dfsg.1-5) unstable; urgency=low

  * _Really_ remove Multi-Arch. Closes: #670033.
  * Standards-Version: 3.9.3 now.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 24 Apr 2012 18:05:26 +0100

xdmf (2.1.dfsg.1-4) unstable; urgency=low

  * Remove Multi-Arch: same from -dev. It isn't. Closes: #657607.
  * Rebuild against HDF5-1.8.8

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 30 Jan 2012 10:07:48 +0000

xdmf (2.1.dfsg.1-3) unstable; urgency=low

  * Multi-Arch support. 

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 05 Oct 2011 11:41:28 +0100

xdmf (2.1.dfsg.1-2) unstable; urgency=low

  * Upload to unstable. 

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 15 Jul 2011 14:00:51 +0100

xdmf (2.1.dfsg.1-1) experimental; urgency=low

  * Removed metis directory and re-upload dfsg.1 version. METIS code
    has no open license.

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 09 Jul 2011 10:33:32 +0100

xdmf (2.1-1) experimental; urgency=low

  * Initial release. (Closes: #623453)

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 19 Apr 2011 14:33:43 +0100
