=== debian/control ===
Source: xdmf
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 9), cmake (>= 2.4.0), libhdf5-mpi-dev, libxml2-dev, python-all-dev, python-support, gfortran, chrpath, mpi-default-dev
Standards-Version: 3.9.5
Homepage: http://www.xmdf.org/

Package:  libxdmf2
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: eXtensible Data Model and Format library
 The need for a standardized method to exchange scientific data between 
 High Performance Computing codes and tools lead to the development of the 
 eXtensible Data Model and Format (XDMF) . Uses for XDMF range from a 
 standard format used by HPC codes to take advantage of widely used 
 visualization programs like ParaView and VisIt, 
 to a mechanism for performing coupled calculations using multiple, 
 previously stand alone codes.
 .
 XDMF uses XML to store Light data and to describe the data Model. 
 HDF5 is used to store Heavy data. The data Format is stored redundantly
 in both XML and HDF5. This allows tools to parse XML to determine the 
 resources that will be required to access the Heavy data. 

Package: libxdmf-dev
Section: libdevel
Architecture: any
Depends: libxdmf2  (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: eXtensible Data Model and Format development tools
 This package contains the headers and development tools needed to build
 against the Xdmf libraries.
