=== debian/rules ===
#!/usr/bin/make -f

# export DH_VERBOSE=1


# The magic debhelper rule:
%:
	dh $@ --buildsystem cmake  

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
TMPDIR=debian/tmp
LIBDIR=usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_install:
	dh_auto_install
	# dh_install can't rename, so do it manually.
	mkdir -p $(TMPDIR)/$(LIBDIR)
	mv $(TMPDIR)/usr/lib/libXdmf.so.2	      $(TMPDIR)/$(LIBDIR)/libXdmf.so.2.1
	mkdir -p $(TMPDIR)/$(LIBDIR)/cmake
	mv $(TMPDIR)/usr/lib/XdmfCMake	$(TMPDIR)/$(LIBDIR)/cmake
	# Fix perms.
	find Examples -type f -exec chmod -x {} \;
	dh_link -p libxdmf-dev $(LIBDIR)/libXdmf.so.2.1         $(LIBDIR)/libXdmf.so
	dh_link -p libxdmf2 $(LIBDIR)/libXdmf.so.2.1         $(LIBDIR)/libXdmf.so.2

override_dh_auto_clean:
	dh_auto_clean
	-find . -name CVS -exec rm -rf {} \;
